﻿* Encoding: UTF-8.
*Clustering tendency
*SPSS macros by Kirill Orlov
*kior@akado.ru, ttnphns@gmail.com
*https://www.spsstools.net/en/KO-spssmacros
*All rights reserved.

*/*!KO_BLOCKDIAG*/vers1***************************************************************************************.
define !KO_blockdiag(matrix= !charend('/') /id= !charend('/') /method= !charend('/') /poster= !charend('/') /plot= !charend('/')
                    /bounds= !charend('/') /mds= !charend('/'))
dataset decl heatmap.#$ window= hidden.
dataset decl blockdiag.#$.
set mxloops 1E6.
matrix.
print /title '**** БЛОК-ДИАГОНАЛИЗАЦИЯ ****'.
!let !matr= !matrix !let !fcrop= 0 !let !lcrop= 0
!if (!substr(!matr,1,1)='?') !then !let !matr= !substr(!matr,2) !let !fcrop= 1 !ifend
!let !lm= !len(!matr)
!if (!substr(!matr,!lm,1)='?') !then !let !matr= !substr(!conc(' ',!matr),1,!lm) !let !lcrop= 1 !ifend
comp ok= 1.
get m /vari= !matr /names= cnam.
!if (!fcrop) !then
-comp m= m(:,2:ncol(m)).
-comp cnam= cnam(:,2:ncol(cnam)). 
!ifend
!if (!lcrop) !then
-comp m= m(:,1:(ncol(m)-1)).
-comp cnam= cnam(:,1:(ncol(cnam)-1)).
!ifend
!if (!id<>!null) !then
-get id /var= !id.
!ifend
get rnam /var= varname_.
comp rnam= t(rnam).
do if nrow(m)<>ncol(m).
-comp cmp= 1.
else if any(rnam<>cnam).
-comp cmp= 1.
else.
-comp cmp= 0.
end if.
do if cmp.
-comp flag= kroneker(t(cnam),make(1,ncol(rnam),1))=kroneker(rnam,make(ncol(cnam),1,1)).
-comp ind2= rmax((flag=1)&*(1:ncol(flag))(make(1,nrow(flag),1),:)).
-release flag.
-comp nnz= msum(ind2>0).
-do if nnz<3.
- print /title '>ERROR. Среди имен столбцов и рядов входящей матрицы слишком мало'.
- print /title '>одинаковых, чтобы составить матрицу для анализа.' /space= 0.
- comp ok= 0.
-else.
- comp ind1= make(1,nnz,0).
- comp cnt= 0.
- loop i= 1 to nrow(ind2).
-  do if ind2(i).
-   comp cnt= cnt+1.
-   comp ind1(cnt)= i.
-  end if.
- end loop.
- comp ind2= ind2(ind1).
- comp m= m(ind2,ind1).
- comp cnam= cnam(ind1).
 !if (!id<>!null) !then
- comp id= id(ind2).
 !ifend
-end if.
end if.
release rnam.
!if (!method='MDS') !then
-do if ncol(m)>700.
- print /title '>ERROR. METHOD=MDS, но составленная для анализа матрица размером больше 700.'.
- comp ok= 0.
-end if.
!ifend
do if any(m<>t(m)).
-print /title '>ERROR. Составленная для анализа матрица не симметрична.'.
-comp ok= 0.
end if.
do if ok. 
 !if (!method='MDS') !then !let !weights= !null
- comp n= ncol(m).
- comp @n1= n+1.
- comp @1n= 1-n.
- comp @nn1= n*(n-1).
- comp tri= reshape(m,n**2,1).
- comp @uind= make(1,@nn1/2,0).
- loop @i= 1 to n-1.
-  comp @st= @1n+@i*(n-@i/2+.5).
-  comp @ind= (@i*@n1+@1n):(@i*n).
-  comp @pos= @st:(@st+ncol(@ind)-1).
-  comp @uind(@pos)= @ind.
- end loop.
- comp tri= tri(@uind).
- comp w1= 1/rnkorder(tri).
- comp @vec= w1.
- comp size= .5+sqrt(.25+2*nrow(@vec)).
- comp @n1= size+1.
- comp @1n= 1-size.
- comp @uind= make(1,nrow(@vec),0).
- loop @i= 1 to size-1.
-  comp @st= @1n+@i*(size-@i/2+.5).
-  comp @ind= (@i*@n1+@1n):(@i*size).
-  comp @uind(@st:(@st+ncol(@ind)-1))= @ind.
- end loop.
- comp w1= make(size**2,1,0).
- comp w1(@uind)= @vec.
- comp w1= reshape(w1,size,size).
- comp w1= w1+t(w1).
- comp w2= make(n,n,0).
- call setdiag(m,1E300).
- loop i= 1 to n.
-  comp w2(i,:)= rnkorder(m(i,:)).
- end loop.
- comp w2= 1/sqrt(w2&*t(w2)).
- call setdiag(w2,0).
- call setdiag(m,0).
- comp w= sqrt(w1&*w2).
- comp wnam=
   {'@001#._','@002#._','@003#._','@004#._','@005#._','@006#._','@007#._','@008#._','@009#._','@010#._',
    '@011#._','@012#._','@013#._','@014#._','@015#._','@016#._','@017#._','@018#._','@019#._','@020#._',
    '@021#._','@022#._','@023#._','@024#._','@025#._','@026#._','@027#._','@028#._','@029#._','@030#._',
    '@031#._','@032#._','@033#._','@034#._','@035#._','@036#._','@037#._','@038#._','@039#._','@040#._',
    '@041#._','@042#._','@043#._','@044#._','@045#._','@046#._','@047#._','@048#._','@049#._','@050#._',
    '@051#._','@052#._','@053#._','@054#._','@055#._','@056#._','@057#._','@058#._','@059#._','@060#._',
    '@061#._','@062#._','@063#._','@064#._','@065#._','@066#._','@067#._','@068#._','@069#._','@070#._',
    '@071#._','@072#._','@073#._','@074#._','@075#._','@076#._','@077#._','@078#._','@079#._','@080#._',
    '@081#._','@082#._','@083#._','@084#._','@085#._','@086#._','@087#._','@088#._','@089#._','@090#._',
    '@091#._','@092#._','@093#._','@094#._','@095#._','@096#._','@097#._','@098#._','@099#._','@100#._',
    '@101#._','@102#._','@103#._','@104#._','@105#._','@106#._','@107#._','@108#._','@109#._','@110#._',
    '@111#._','@112#._','@113#._','@114#._','@115#._','@116#._','@117#._','@118#._','@119#._','@120#._',
    '@121#._','@122#._','@123#._','@124#._','@125#._','@126#._','@127#._','@128#._','@129#._','@130#._',
    '@131#._','@132#._','@133#._','@134#._','@135#._','@136#._','@137#._','@138#._','@139#._','@140#._',
    '@141#._','@142#._','@143#._','@144#._','@145#._','@146#._','@147#._','@148#._','@149#._','@150#._',
    '@151#._','@152#._','@153#._','@154#._','@155#._','@156#._','@157#._','@158#._','@159#._','@160#._',
    '@161#._','@162#._','@163#._','@164#._','@165#._','@166#._','@167#._','@168#._','@169#._','@170#._',
    '@171#._','@172#._','@173#._','@174#._','@175#._','@176#._','@177#._','@178#._','@179#._','@180#._',
    '@181#._','@182#._','@183#._','@184#._','@185#._','@186#._','@187#._','@188#._','@189#._','@190#._',
    '@191#._','@192#._','@193#._','@194#._','@195#._','@196#._','@197#._','@198#._','@199#._','@200#._',
    '@201#._','@202#._','@203#._','@204#._','@205#._','@206#._','@207#._','@208#._','@209#._','@210#._',
    '@211#._','@212#._','@213#._','@214#._','@215#._','@216#._','@217#._','@218#._','@219#._','@220#._',
    '@221#._','@222#._','@223#._','@224#._','@225#._','@226#._','@227#._','@228#._','@229#._','@230#._',
    '@231#._','@232#._','@233#._','@234#._','@235#._','@236#._','@237#._','@238#._','@239#._','@240#._',
    '@241#._','@242#._','@243#._','@244#._','@245#._','@246#._','@247#._','@248#._','@249#._','@250#._',
    '@251#._','@252#._','@253#._','@254#._','@255#._','@256#._','@257#._','@258#._','@259#._','@260#._',
    '@261#._','@262#._','@263#._','@264#._','@265#._','@266#._','@267#._','@268#._','@269#._','@270#._',
    '@271#._','@272#._','@273#._','@274#._','@275#._','@276#._','@277#._','@278#._','@279#._','@280#._',
    '@281#._','@282#._','@283#._','@284#._','@285#._','@286#._','@287#._','@288#._','@289#._','@290#._',
    '@291#._','@292#._','@293#._','@294#._','@295#._','@296#._','@297#._','@298#._','@299#._','@300#._',
    '@301#._','@302#._','@303#._','@304#._','@305#._','@306#._','@307#._','@308#._','@309#._','@310#._',
    '@311#._','@312#._','@313#._','@314#._','@315#._','@316#._','@317#._','@318#._','@319#._','@320#._',
    '@321#._','@322#._','@323#._','@324#._','@325#._','@326#._','@327#._','@328#._','@329#._','@330#._',
    '@331#._','@332#._','@333#._','@334#._','@335#._','@336#._','@337#._','@338#._','@339#._','@340#._',
    '@341#._','@342#._','@343#._','@344#._','@345#._','@346#._','@347#._','@348#._','@349#._','@350#._',
    '@351#._','@352#._','@353#._','@354#._','@355#._','@356#._','@357#._','@358#._','@359#._','@360#._',
    '@361#._','@362#._','@363#._','@364#._','@365#._','@366#._','@367#._','@368#._','@369#._','@370#._',
    '@371#._','@372#._','@373#._','@374#._','@375#._','@376#._','@377#._','@378#._','@379#._','@380#._',
    '@381#._','@382#._','@383#._','@384#._','@385#._','@386#._','@387#._','@388#._','@389#._','@390#._',
    '@391#._','@392#._','@393#._','@394#._','@395#._','@396#._','@397#._','@398#._','@399#._','@400#._',
    '@401#._','@402#._','@403#._','@404#._','@405#._','@406#._','@407#._','@408#._','@409#._','@410#._',
    '@411#._','@412#._','@413#._','@414#._','@415#._','@416#._','@417#._','@418#._','@419#._','@420#._',
    '@421#._','@422#._','@423#._','@424#._','@425#._','@426#._','@427#._','@428#._','@429#._','@430#._',
    '@431#._','@432#._','@433#._','@434#._','@435#._','@436#._','@437#._','@438#._','@439#._','@440#._',
    '@441#._','@442#._','@443#._','@444#._','@445#._','@446#._','@447#._','@448#._','@449#._','@450#._',
    '@451#._','@452#._','@453#._','@454#._','@455#._','@456#._','@457#._','@458#._','@459#._','@460#._',
    '@461#._','@462#._','@463#._','@464#._','@465#._','@466#._','@467#._','@468#._','@469#._','@470#._',
    '@471#._','@472#._','@473#._','@474#._','@475#._','@476#._','@477#._','@478#._','@479#._','@480#._',
    '@481#._','@482#._','@483#._','@484#._','@485#._','@486#._','@487#._','@488#._','@489#._','@490#._',
    '@491#._','@492#._','@493#._','@494#._','@495#._','@496#._','@497#._','@498#._','@499#._','@500#._',
    '@501#._','@502#._','@503#._','@504#._','@505#._','@506#._','@507#._','@508#._','@509#._','@510#._',
    '@511#._','@512#._','@513#._','@514#._','@515#._','@516#._','@517#._','@518#._','@519#._','@520#._',
    '@521#._','@522#._','@523#._','@524#._','@525#._','@526#._','@527#._','@528#._','@529#._','@530#._',
    '@531#._','@532#._','@533#._','@534#._','@535#._','@536#._','@537#._','@538#._','@539#._','@540#._',
    '@541#._','@542#._','@543#._','@544#._','@545#._','@546#._','@547#._','@548#._','@549#._','@550#._',
    '@551#._','@552#._','@553#._','@554#._','@555#._','@556#._','@557#._','@558#._','@559#._','@560#._',
    '@561#._','@562#._','@563#._','@564#._','@565#._','@566#._','@567#._','@568#._','@569#._','@570#._',
    '@571#._','@572#._','@573#._','@574#._','@575#._','@576#._','@577#._','@578#._','@579#._','@580#._',
    '@581#._','@582#._','@583#._','@584#._','@585#._','@586#._','@587#._','@588#._','@589#._','@590#._',
    '@591#._','@592#._','@593#._','@594#._','@595#._','@596#._','@597#._','@598#._','@599#._','@600#._',
    '@601#._','@602#._','@603#._','@604#._','@605#._','@606#._','@607#._','@608#._','@609#._','@610#._',
    '@611#._','@612#._','@613#._','@614#._','@615#._','@616#._','@617#._','@618#._','@619#._','@620#._',
    '@621#._','@622#._','@623#._','@624#._','@625#._','@626#._','@627#._','@628#._','@629#._','@630#._',
    '@631#._','@632#._','@633#._','@634#._','@635#._','@636#._','@637#._','@638#._','@639#._','@640#._',
    '@641#._','@642#._','@643#._','@644#._','@645#._','@646#._','@647#._','@648#._','@649#._','@650#._',
    '@651#._','@652#._','@653#._','@654#._','@655#._','@656#._','@657#._','@658#._','@659#._','@660#._',
    '@661#._','@662#._','@663#._','@664#._','@665#._','@666#._','@667#._','@668#._','@669#._','@670#._',
    '@671#._','@672#._','@673#._','@674#._','@675#._','@676#._','@677#._','@678#._','@679#._','@680#._',
    '@681#._','@682#._','@683#._','@684#._','@685#._','@686#._','@687#._','@688#._','@689#._','@690#._',
    '@691#._','@692#._','@693#._','@694#._','@695#._','@696#._','@697#._','@698#._','@699#._','@700#._'}.
- comp wnam= wnam(1:ncol(cnam)).
- comp names= {cnam,wnam}.
  !if (!id<>!null) !then
-  comp names= {!quote(!id),names}.
  !ifend
- save {!if (!id<>!null) !then id, !ifend m,w} /out= * /names= names.
- write {'proxscal',' vari='} /outfile= 'temp_KO_blockdiag_2.sps' /field= 1 to 16 /format= a8.
- write cnam /field= 2 to 65 /format= a8.
- write {'/weigh=',wnam} /field= 2 to 65 /format= a8.
- write {'/prox=','dissim','/init=','simplex'} /field= 2 to 33 /format= a8.
- write {'/trans=', !if (!mds=!null) !then 'spline' !else !quote(!mds) !ifend} /field= 2 to 33 /format= a8.
- write {'/crit=','dim(1)'} /field= 2 to 33 /format= a8.
- write {'/print=','none','/plot=','none'} /field= 2 to 33 /format= a8.
- write {'/outf=','common(','coord.#$',').'} /field= 2 to 33 /format= a8.
- else. 
-  print /title '>!KO_BLOCKDIAG выполнен неверно.' /space= 0.
-  save 0 /out= *.
- end if.
- end matrix.
- dataset decl coord.#$ window= hidden.
- insert file= 'temp_KO_blockdiag_2.sps'.
- match files /file= * file= coord.#$.
- exec.
- dataset close coord.#$.
- matrix.
- get m /names= cnam.
  !if (!id<>!null) !then
-  comp id= m(:,1).
-  comp m= m(:,2:ncol(m)).
-  comp cnam= cnam(2:ncol(cnam)).
  !ifend
- comp coord= m(:,ncol(m)).
- comp m= m(:,1:(ncol(m)-1)).
- comp cnam= cnam(1:(ncol(cnam)-1)).
- comp m= m(:,1:(ncol(m)/2)).
- comp cnam= cnam(1:(ncol(cnam)/2)).
- comp coord= grade(coord).
- comp cnam(coord)= cnam.
- comp m(coord,coord)= m.
  !if (!id<>!null) !then
-  comp id(coord)= id.
  !ifend
  !if (!poster='YES') !then
-  comp m2= m.
-  comp @n= ncol(m2).
-  loop @k= 1 to @n.
-   loop @i= 1 to @n.
-    do if @i<>@k.
-     comp @dik= m2(@i,@k).
-     loop @j= @i+1 to @n.
-      do if m2(@i,@j)>rmax({@dik,m2(@k,@j)}).
-       comp m2(@i,@j)= rmax({@dik,m2(@k,@j)}).
-      end if.
-     end loop.
-     comp m2(:,@i)= t(m2(@i,:)).
-    end if.
-   end loop.
-  end loop.
  !else
-  comp m2= m.
  !ifend
 !else
- comp @n= ncol(m).
- call setdiag(m,1E300).
- comp ind= mmax((m=mmin(m))&*(1:@n)(make(1,@n,1),:)).
- call setdiag(m,0).
- do if ind=1.
-  comp @out= 2:@n.
- else if ind=@n.
-  comp @out= 1:(@n-1).
- else.
-  comp @out= {1:(ind-1),(ind+1):@n}.
- end if.
  !if (!poster='YES') !then
-  comp @rilst= 0.
  !ifend
- loop @i= 2 to @n.
-  comp @m= m(ind,@out).
-  comp @val= mmin(@m).
-  comp @m= @m=@val.
-  comp @ci= mmax(@m&*(ncol(@m):1)(make(1,nrow(@m),1),:)).
-  comp @ci= ncol(@m)+1-@ci.
-  comp ind= {ind,@out(@ci)}.
  !if (!poster='YES') !then
-  comp @ri= mmax(@m(:,@ci)&*t(nrow(@m):1)).
-  comp @ri= nrow(@m)+1-@ri.
-  comp @rilst= {@rilst,@ri}.
  !ifend
-  do if @i<@n.
-   do if @ci=1.
-    comp @out= @out(2:ncol(@out)).
-   else if @ci=ncol(@out).
-    comp @out= @out(1:(ncol(@out)-1)).
-   else.
-    comp @out= @out({1:(@ci-1),(@ci+1):ncol(@out)}).
-   end if.
-  end if.
- end loop.
- comp m= m(ind,ind).
- comp cnam= cnam(ind).
  !if (!id<>!null) !then
-  comp id= id(ind).
  !ifend
- release @out,@ci.
  !if (!poster='YES') !then
-  comp @m= make(@n,@n,0).
-  loop @i= 2 to @n.
-   comp @j= @rilst(@i).
-   comp @val= m(@i,@j).
-   comp @m(@i,1:(@i-1))= make(1,@i-1,@val).
-   loop @c= 1 to @j-1.
-    comp @m(@i,@c)= mmax({@val,@m(@j,@c)}).
-   end loop.
-  end loop.
-  comp m2= @m+t(@m).
-  release @rilst,@ri,@j,@c.
  !else
-  comp m2= m.
  !ifend
- release @n,@i,@val,@m.
 !ifend
 !if (!plot<>'NONE') !then
- save {{kroneker(t(cnam),make(ncol(cnam),1,1)),kroneker(make(ncol(cnam),1,1),t(cnam))},
        reshape(m2,ncol(m2)**2,1)} /out= heatmap.#$ /vari= row col val /string= row col.
 !ifend
 !if (!id<>!null) !then
- comp names= {'rowtype_',!quote(!id),'varname_',cnam}.
 !else
- comp names= {'rowtype_','varname_',cnam}.
 !ifend
-save {make(nrow(m),1,'PROX'), !if (!id<>!null) !then id, !ifend t(cnam),m}
      /out= blockdiag.#$ /names= names /string= rowtype_ varname_.
!if (!method<>'MDS') !then
-else.
- print /title '>!KO_BLOCKDIAG выполнен неверно.' /space= 0.
- save 0 /out= *.
-end if.
!ifend
end matrix.
!if (!plot<>'NONE') !then
 !let !element= 'ELEMENT: polygon(position(col*row),color(color.grey),color.brightness.exterior(val),color.brightness.interior(val)'
 !let !scale1= 'SCALE: linear(aesthetic(aesthetic.color.brightness.interior)'
 !let !scale2= 'SCALE: linear(aesthetic(aesthetic.color.brightness.exterior)'
 !if (!head(!plot)='RGREY') !then !let !scale1= !conc(!scale1,',reverse()') !let !scale2= !conc(!scale2,',reverse()') !ifend
 !if (!tail(!plot)=' LABEL') !then !let !lbl= ',label(val)' !ifend
 !if (!bounds='OBS') !then
  !let !scale1= !conc(!scale1,',dataMinimum(),dataMaximum()') !let !scale2= !conc(!scale2,',dataMinimum(),dataMaximum()')
 !else !if (!bounds<>'AUTO' !and !bounds<>!null) !then
  !if (!head(!bounds)='-') !then !let !bmin= !conc('-',!head(!tail(!bounds))) !let !bmax= !tail(!tail(!bounds))
  !else !let !bmin= !head(!bounds) !let !bmax= !tail(!bounds)
  !ifend
  !let !scale1= !conc(!scale1,',min(',!bmin,'),max(',!bmax,')') !let !scale2= !conc(!scale2,',min(',!bmin,'),max(',!bmax,')')
 !ifend !ifend
-dataset activ heatmap.#$.
-var lev val (sca).
-do if $casenum=1.
- write outfile= 'temp_KO_blockdiag_1.sps'
      /'PAGE: begin(scale(800px,620px))'
      /'SOURCE: s=userSource(id("graphdataset"))'
      /'DATA: row=col(source(s),name("row"),unit.category())'
      /'DATA: col=col(source(s),name("col"),unit.category())'
      /'DATA: val=col(source(s),name("val"))'
      /'GUIDE: axis(dim(1),label(" "),gridlines())'
      /'GUIDE: axis(dim(2),label(" "),gridlines())'
      /'GUIDE: legend(aesthetic(aesthetic.color.brightness.exterior),null())'
      /'SCALE: cat(dim(1),sort.data())'
      /'SCALE: cat(dim(2),sort.data(),reverse())'
      /!quote(!conc(!scale1,')'))
      /!quote(!conc(!scale2,')'))
      /!quote(!conc(!element,!lbl,')'))
      /'PAGE: end()'.
-end if.
-GGRAPH /GRAPHDATASET NAME= "graphdataset" VARIABLES= col row val
       /GRAPHSPEC SOURCE= GPLFILE('temp_KO_blockdiag_1.sps').
-dataset close heatmap.#$.
-dataset activ blockdiag.#$.
-dataset close *.
-val lab rowtype_ 'PROX' 'DISSIMILARITY'.
 !if (!id<>!null) !then
- var lev !id (nom).
 !ifend
-erase file 'temp_KO_blockdiag_1.sps'.
!ifend
!if (!method='MDS') !then
-erase file 'temp_KO_blockdiag_2.sps'.
!ifend
!enddefine.
